package org.netkernel.jabber.endpoint;

import org.jivesoftware.smack.Chat;
import org.jivesoftware.smack.packet.Message;
import org.netkernel.container.IKernel;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFRequestReadOnly;
import org.netkernel.layer0.nkf.INKFResolutionContext;
import org.netkernel.layer0.nkf.impl.NKFSpaceImpl;
import org.netkernel.urii.IEndpoint;

public class ChatSpace extends NKFSpaceImpl
{	private Chat mChat;
	private static IEndpoint sEndpoint = new ChatSpaceEndpoint(); 
	private static final String CHAT_RESPONSE_SCHEME="jabber:reply";

	public ChatSpace(Chat aChat)
	{	mChat=aChat;
	}

	@Override
	public void onCommissionSpace(IKernel kernel) throws Exception
	{	super.onCommissionSpace(kernel);
		sEndpoint.onCommissionEndpoint(kernel, this);
	}

	@Override
	public void onResolve(INKFResolutionContext context) throws Exception
	{	String requestId = context.getRequestToResolve().getIdentifier();
		if (context.getRequestToResolve().getVerb()==INKFRequestReadOnly.VERB_SINK && requestId.startsWith(CHAT_RESPONSE_SCHEME))
		{	context.createResolutionResponse(sEndpoint);
		}
	}
	
	public void handleRequestFromEndpoint(INKFRequestContext context) throws Exception
	{	Object primary=context.sourcePrimary(Object.class);
		if(primary instanceof String)
		{	mChat.sendMessage((String)primary);
		}
		else if(primary instanceof Message)
		{	mChat.sendMessage((Message)primary);			
		}
		else
		{	primary=context.sourcePrimary(String.class);
			mChat.sendMessage((String)primary);
		}
	}
	
}
